\ Module for searching in ZCPR3 Named directory buffer (NDR)
\ Pavel Zampach, 2020
\ *

\ addr of NDR buffer
: NDR-ADDR ( -- addr )
  zenv dup if 21 + @ end
;

\ ndr item addr -> dir name (addr-c u)
: ADR>NAME ( addr -- addr-c u )
  2+ 8 -trailing
;

\ addr of next NDR item
: NDR-NEXT ( addr1 -- addr2 )
  18 +
;

behead ndr-addr ndr-next

\ ----- Interface -----

\ search for disk (A = 1) and user, returns dir name (addr-c u)
\ a = u = 0 if nothing was found or NDR is not implemented
: NDR-NAME ( disk user -- addr-c u )
  >< or          \ high byte = user, low byte = disk
  ndr-addr       \ du addr-ndr -- ;
  dup if
    begin
      dup c@     \ end?
    while
      2dup @ = if
        nip adr>name
      end
      ndr-next
    repeat
  then
  2drop 0 0      \ not found
;

\ search for dir name (addr-c u), returns disk (A = 1) and user
\ disk = user = FALSE if nothing was found or NDR is not implemented
: NDR-UD ( addr-c u -- disk user )
  2dup upper
  ndr-addr       \ addr-c u addr-ndr -- ;
  dup if
    begin
      dup c@     \ end?
    while
      dup >r     \ save item addr
      adr>name 2over compare 0= if
        2drop r@ c@ r> 1+ c@
      end
      r> ndr-next
    repeat
  then
  drop 2drop 0 0 \ not found
;